0f4b25db82eced8fc209e7cfa47fd889fe08029c
[releng.git] / utils / fetch_os_creds.sh
1 #!/bin/bash
2 ##############################################################################
3 # Copyright (c) 2015 Ericsson AB and others.
4 # jose.lausuch@ericsson.com
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11
12 usage() {
13     echo "usage: $0 [-v] -d <destination> -i <installer_type> -a <installer_ip>" >&2
14     echo "[-v] Virtualized deployment" >&2
15 }
16
17 info ()  {
18     logger -s -t "fetch_os_creds.info" "$*"
19 }
20
21
22 error () {
23     logger -s -t "fetch_os_creds.error" "$*"
24     exit 1
25 }
26
27
28 verify_connectivity() {
29     local ip=$1
30     info "Verifying connectivity to $ip..."
31     for i in $(seq 0 10); do
32         if ping -c 1 -W 1 $ip > /dev/null; then
33             info "$ip is reachable!"
34             return 0
35         fi
36         sleep 1
37     done
38     error "Can not talk to $ip."
39 }
40
41 : ${DEPLOY_TYPE:=''}
42
43 #Get options
44 while getopts ":d:i:a:h:v" optchar; do
45     case "${optchar}" in
46         d) dest_path=${OPTARG} ;;
47         i) installer_type=${OPTARG} ;;
48         a) installer_ip=${OPTARG} ;;
49         v) DEPLOY_TYPE="virt" ;;
50         *) echo "Non-option argument: '-${OPTARG}'" >&2
51            usage
52            exit 2
53            ;;
54     esac
55 done
56
57 # set vars from env if not provided by user as options
58 dest_path=${dest_path:-$HOME/opnfv-openrc.sh}
59 installer_type=${installer_type:-$INSTALLER_TYPE}
60 installer_ip=${installer_ip:-$INSTALLER_IP}
61
62 if [ -z $dest_path ] || [ -z $installer_type ] || [ -z $installer_ip ]; then
63     usage
64     exit 2
65 fi
66
67 # Checking if destination path is valid
68 if [ -d $dest_path ]; then
69     error "Please provide the full destination path for the credentials file including the filename"
70 else
71     # Check if we can create the file (e.g. path is correct)
72     touch $dest_path || error "Cannot create the file specified. Check that the path is correct and run the script again."
73 fi
74
75
76 ssh_options="-o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no"
77
78 # Start fetching the files
79 if [ "$installer_type" == "fuel" ]; then
80     #ip_fuel="10.20.0.2"
81     verify_connectivity $installer_ip
82
83     env=$(sshpass -p r00tme ssh 2>/dev/null $ssh_options root@${installer_ip} \
84         'fuel env'|grep operational|head -1|awk '{print $1}') &> /dev/null
85     if [ -z $env ]; then
86         error "No operational environment detected in Fuel"
87     fi
88     env_id="${FUEL_ENV:-$env}"
89
90     # Check if controller is alive (online='True')
91     controller_ip=$(sshpass -p r00tme ssh 2>/dev/null $ssh_options root@${installer_ip} \
92         "fuel node --env ${env_id} | grep controller | grep 'True\|  1' | awk -F\| '{print \$5}' | head -1" | \
93         sed 's/ //g') &> /dev/null
94
95     if [ -z $controller_ip ]; then
96         error "The controller $controller_ip is not up. Please check that the POD is correctly deployed."
97     fi
98
99     info "Fetching rc file from controller $controller_ip..."
100     sshpass -p r00tme ssh 2>/dev/null $ssh_options root@${installer_ip} \
101         "scp $ssh_options ${controller_ip}:/root/openrc ." &> /dev/null
102     sshpass -p r00tme scp 2>/dev/null $ssh_options root@${installer_ip}:~/openrc $dest_path &> /dev/null
103
104     #This file contains the mgmt keystone API, we need the public one for our rc file
105     admin_ip=$(cat $dest_path | grep "OS_AUTH_URL" | sed 's/^.*\=//' | sed "s/^\([\"']\)\(.*\)\1\$/\2/g" | sed s'/\/$//')
106     public_ip=$(sshpass -p r00tme ssh $ssh_options root@${installer_ip} \
107         "ssh ${controller_ip} 'source openrc; openstack endpoint list --long'" \
108         | grep $admin_ip | sed 's/ /\n/g' | grep ^http | head -1) &> /dev/null
109         #| grep http | head -1 | cut -d '|' -f 4 | sed 's/v1\/.*/v1\//' | sed 's/ //g') &> /dev/null
110     #NOTE: this is super ugly sed 's/v1\/.*/v1\//'OS_AUTH_URL
111     # but sometimes the output of endpoint-list is like this: http://172.30.9.70:8004/v1/%(tenant_id)s
112     # Fuel virtual need a fix
113
114     if [ "$DEPLOY_TYPE" == "virt" ]; then
115         echo "INFO: Changing: internalURL -> publicURL in openrc"
116         sed -i 's/internalURL/publicURL/' $dest_path
117     fi
118
119 elif [ "$installer_type" == "apex" ]; then
120     verify_connectivity $installer_ip
121
122     # The credentials file is located in the Instack VM (192.0.2.1)
123     # NOTE: This might change for bare metal deployments
124     info "Fetching rc file from Instack VM $installer_ip..."
125     if [ -f /root/.ssh/id_rsa ]; then
126         chmod 600 /root/.ssh/id_rsa
127     fi
128     sudo scp $ssh_options root@$installer_ip:/home/stack/overcloudrc $dest_path
129
130 elif [ "$installer_type" == "compass" ]; then
131     verify_connectivity $installer_ip
132     controller_ip=$(sshpass -p'root' ssh 2>/dev/null $ssh_options root@${installer_ip} \
133         'mysql -ucompass -pcompass -Dcompass -e"select *  from cluster;"' \
134         | awk -F"," '{for(i=1;i<NF;i++)if($i~/\"host[1-5]\"/) {print $(i+1);break;}}'  \
135         | grep -oP "\d+.\d+.\d+.\d+")
136
137     if [ -z $controller_ip ]; then
138         error "The controller $controller_ip is not up. Please check that the POD is correctly deployed."
139     fi
140
141     info "Fetching rc file from controller $controller_ip..."
142     sshpass -p root ssh 2>/dev/null $ssh_options root@${installer_ip} \
143         "scp $ssh_options ${controller_ip}:/opt/admin-openrc.sh ." &> /dev/null
144     sshpass -p root scp 2>/dev/null $ssh_options root@${installer_ip}:~/admin-openrc.sh $dest_path &> /dev/null
145     echo 'export OS_REGION_NAME=regionOne' >> $dest_path
146
147     info "This file contains the mgmt keystone API, we need the public one for our rc file"
148     admin_ip=$(cat $dest_path | grep "OS_AUTH_URL" | sed 's/^.*\=//' | sed "s/^\([\"']\)\(.*\)\1\$/\2/g" | sed s'/\/$//')
149     info "admin_ip: $admin_ip"
150     public_ip=$(sshpass -p root ssh $ssh_options root@${installer_ip} \
151         "ssh ${controller_ip} 'source /opt/admin-openrc.sh; keystone endpoint-list'" \
152         | grep $admin_ip | sed 's/ /\n/g' | grep ^http | head -1)
153     info "public_ip: $public_ip"
154
155
156 elif [ "$installer_type" == "joid" ]; then
157     # do nothing...for the moment
158     # we can either do a scp from the jumphost or use the -v option to transmit the param to the docker file
159     echo "Do nothing, creds will be provided through volume option at docker creation for joid"
160
161 elif [ "$installer_type" == "foreman" ]; then
162     #ip_foreman="172.30.10.73"
163     controller="oscontroller1.opnfv.com"
164     verify_connectivity $installer_ip
165
166     # Check if controller is alive (here is more difficult to get the ip from a command like "fuel node")
167     sshpass -p vagrant ssh $ssh_options root@${installer_ip} \
168         "sshpass -p Op3nStack ssh $ssh_options root@${controller} 'ls'" &> /dev/null
169     if [ $? -ne 0 ]; then
170         error "The controller ${controller} is not up. Please check that the POD is correctly deployed."
171     fi
172
173     info "Fetching openrc from a Foreman Controller '${controller}'..."
174     sshpass -p vagrant ssh $ssh_options root@${installer_ip} \
175         "sshpass -p Op3nStack scp $ssh_options root@${controller}:~/keystonerc_admin ." &> /dev/null
176     sshpass -p vagrant scp $ssh_options root@${installer_ip}:~/keystonerc_admin $dest_path &> /dev/null
177
178     #This file contains the mgmt keystone API, we need the public one for our rc file
179     admin_ip=$(cat $dest_path | grep "OS_AUTH_URL" | sed 's/^.*\=//' | sed "s/^\([\"']\)\(.*\)\1\$/\2/g" | sed s'/\/$//')
180     public_ip=$(sshpass -p vagrant ssh $ssh_options root@${installer_ip} \
181         "sshpass -p Op3nStack ssh $ssh_options root@${controller} \
182         'source keystonerc_admin;keystone endpoint-list'" \
183         | grep $admin_ip | sed 's/ /\n/g' | grep ^http | head -1) &> /dev/null
184
185 else
186     error "Installer $installer is not supported by this script"
187 fi
188
189
190 if [ ! -f $dest_path ]; then
191     error "There has been an error retrieving the credentials"
192 fi
193
194 if [ "$public_ip" != "" ]; then
195     info "Exchanging keystone public IP in rc file to $public_ip"
196     sed -i  "/OS_AUTH_URL/c\export OS_AUTH_URL=\'$public_ip'" $dest_path
197 fi
198
199
200
201 echo "-------- Credentials: --------"
202 cat $dest_path
203
204 exit 0